<?php  if ( ! defined('BASEPATH')) exit('No direct script access allowed');

class Ot_loader extends CI_Loader 
{

	// Extend core model for support role based model loading.
	
	public function model($model, $name = '', $db_conn = FALSE, $role = '')
	{
		if (is_array($model))
		{
			foreach ($model as $babe)
			{
				$this->model($babe);
			}
			return;
		}

		if ($model == '')
		{
			return;
		}

		$path = '';

		// Is the model in a sub-folder? If so, parse out the filename and path.
		if (($last_slash = strrpos($model, '/')) !== FALSE)
		{
			// The path is in front of the last slash
			$path = substr($model, 0, $last_slash + 1);

			// And the model name behind it
			$model = substr($model, $last_slash + 1);
		}

		if ($name == '')
		{
			$name = $model;
		}

		if ($role=='' && in_array($name, $this->_ci_models, TRUE))
		{
			return;
		}

		$CI =& get_instance();
		if ($role=='' && isset($CI->$name))
		{
			show_error('The model name you are loading is the name of a resource that is already being used: '.$name);
		}
		
		$tmp_model = $model = strtolower($model);

		foreach ($this->_ci_model_paths as $mod_path)
		{
			$model = $tmp_model;
			$model_full_path = $mod_path.'models/'.$path.$model.'.php';
			
			//load langugae file if exist		
			$CI->lang->load_model_lang($tmp_model);
			
			
			if ( ! file_exists($model_full_path))
			{
				// check model with prefix or based on role
				$model_full_path = $mod_path.'models/'.$path.'mod.'.$model.'.php';
				if ( ! file_exists($model_full_path)) {
				
					// load model based on user role
					$roles = array('admin'=>'A', 'pmf'=>'F', 'pm'=>'P', 'member'=>'M');
					if (!$role)
					{
						$CI =& get_instance();
						$CI->load->library(OTBASE_PATH.'OT_User');
						$role = $CI->ot_user->get('user_role');
					}
					$role = array_search($role, $roles);
					$model_full_path = $mod_path.'models/'.$path.$model.'/'.'mod.'.$model.'_'.$role.'.php';

					if ( ! file_exists($model_full_path))
					{
						continue;
					} else
					{
						$model = strtolower(strtolower($model.'_'.$role));
					}
				} else {
					$model = strtolower(strtolower($model.'_model'));	
				}
				
			}

			if ($db_conn !== FALSE AND ! class_exists('CI_DB'))
			{
				if ($db_conn === TRUE)
				{
					$db_conn = '';
				}

				$CI->load->database($db_conn, FALSE, TRUE);
			}

			if ( ! class_exists('CI_Model'))
			{
				load_class('Model', 'core');
			}

			require_once($model_full_path);

			$model = ucfirst($model);
			$CI->$name = new $model();

			$this->_ci_models[] = $name;
			return;
		}
		// couldn't find the model
		show_error('Unable to locate the model you have specified: '.$model);
	}

	// Reponse loader
	public function response()
	{
		// Grab the super object
		$CI =& get_instance();

		// Initialize the response variable.
		$class 			= 'response_html';
		$CI->$class 	= '';

		$file_path = APPPATH.'libraries/base/'.ucfirst($class).'.php';		

		// check ajax request
		$is_ajax_req	= $CI->input->is_ajax_request();

		if ($is_ajax_req)
		{
			// if request is ajax then load ajax response class
			$class		= 'response_ajax';
			$file_path = APPPATH.'libraries/base/'.ucfirst($class).'.php';
		}

		require_once($file_path);

		//initialize the reponse class
		$CI->response = new $class();
	}
}