<?php if ( ! defined('BASEPATH')) exit('No direct script access allowed');

class Response_html {

	protected	$_data		= array();

	protected	$_message	= array();

	protected	$_type		= '';

	public $message_code	= array('error' => false, 'success' => true, 'warning' => 2, 'info' => 3);

	public function __construct()
	{
		$this->CI 		= & get_instance();
	}

	public function error($message='', $write=false)
	{
		if ($write === 404)
		{
			show_404();
		}
		$this->set_message($message, 'error', $write);

		return $this;
	}

	public function show_error($message='')
	{
		show_error($message);
		return true;
	}

	public function success($message='', $write=false)
	{
		$this->set_message($message, 'success', $write);

		return $this;
	}

	public function warning($message='', $write=false)
	{
		$this->set_message($message, 'warning', $write);

		return $this;
	}

	public function info($message='', $write=false)
	{
		$this->set_message($message, 'info', $write);

		return $this;
	}

	protected function set_message($message='', $type='error', $write=false)
	{
		$this->_type	= $type;
		if (!empty($message))
		{
			$this->_message[$type][]	= lang($message);
		}

		if ($write === true)
		{
			$this->write();
		}
	}

	public function get_messages($type='')
	{
		$return	= '';
		if (!empty($this->_message))
		{
			if (empty($type))
			{
				foreach ($this->_message as $type=>$msgArr)
				{
					$return[$type]	= nl2br(implode($msgArr, PHP_EOL));
				}
			}
			elseif (!empty($this->_message[$type]))
			{
				$return	= nl2br(implode($this->_message[$type], PHP_EOL));
			}
		}

		return $return;
	}

	public function clear_message($type)
	{
		if (empty($type))
		{
			$this->message	= array();
			return $this;
		}

		unset($this->message[$type]);

		return $this;
	}

	public function set_data($key='', $val='', $prepare=false)
	{
		if (empty($key))
		{
			return $this;
		}

		if (is_array($key))
		{
			if ($val === true)
			{
				$key	= $this->prepare($key);
			}
			$this->_data	= array_merge($this->_data, $key);
		}
		elseif(is_string($key))
		{
			if ($prepare == true)
			{
				$val	= $this->prepare($val);
			}
			$this->_data[$key]	= $val;
		}

		return $this;
	}

	public function prepare($data)
	{
		if (!empty($data))
		{
			$format_data	= array('otkeys'=>array(), 'otvalues'=>array());

			$format_data['otkeys']	= array_keys(reset($data));

			foreach ($data as $row)
			{
				$format_data['otvalues'][]	= array_values($row);
// 				$format_data['otkeys']		= array_merge($format_data['otkeys'], array_keys($row));
			}
// 			$format_data['otkeys']	= array_values(array_unique($format_data['otkeys']));

			$data	= $format_data;
		}

		return $data;
	}

	public function get_data($key='', $default='')
	{
		if (empty($key))
		{
			return $this->_data;
		}

		return (array_key_exists($key, $this->_data)) ? $this->_data[$key] : $default;
	}

	public function unset_data($key='')
	{
		if (empty($key))
		{
			return false;
		}

		$key	= is_array($key) ? $key : array($key);

		foreach ($key as $k=>$v)
		{
			unset($this->_data[$v]);
		}

		return $this;
	}

	public function truncate_data()
	{
		$this->_data	= array();
		return $this;
	}

	public function write($data='')
	{
		// $this->set_data($data);

		$messages	= $this->get_messages();

		if (!empty($messages) && is_array($messages))
		{
			foreach ($messages as $type=>$msg)
			{
				$this->CI->session->set_flashdata($type, $msg);
			}
		}

		if (!empty($data['redirect']))
		{
			redirect($data['redirect']);
		}

		return true;
	}
}
