<?php if ( ! defined('BASEPATH')) exit('No direct script access allowed');

class Bookmarks_model extends CI_Model {

	public $error	= '';

	function __construct()
	{
		parent::__construct();
	}
	
	public function items($id=0)
	{
		$this->db->select('id, name, filters, type, url');
		$this->db->from('bookmarks');
		$this->db->where('user_id', $this->ot_user->get('user_id'));
		$this->db->order_by('view','desc');
		if ($id)
		{
			$this->db->where('id',$id);
		}
		$query = $this->db->get();
		
		return $query->result_array();
	}

	public function item($id)
	{
		$result	= array();
		$this->db->where('id', $id);
		$this->db->set('view', 'view+1', FALSE);
		$this->db->update('bookmarks');

		if ($this->db->affected_rows())
		{
			$this->db->select('filters');
			$this->db->from('bookmarks');
			$this->db->where(array(
				'id'		=> $id,
				'user_id'	=> $this->ot_user->get('user_id')
			));

			$query	= $this->db->get();
			$result	= $query->row_array();
		}

		return $result;
	}
	
	public function save($data)
	{
		$this->load->library('bookmarks_table');
		
		if (!$result = $this->bookmarks_table->save($data))
		{
			return false;
		} 		
		
		return array('id' => $result);
	}

	public function delete ($id)
	{
		if(!$this->db->delete('bookmarks', array('id' => $id, 'user_id'=>$this->ot_user->get('user_id'))))
			return false; 
		return true;
	}
}

/* End of file mod.client.php */